$CHIP=6301		;select 6301 chip
$NOLIST			;dont want list output

				%INCLUDE		"equates.asm"
				%INCLUDE		"globals.ext"
				%INCLUDE		"segaemu.ext"
				%INCLUDE		"macro.asm"

				DEFSEG			mainSeg
				SEG				mainSeg
;
;SendCommandToIBM, send a command to the IBM via the 8 bit data lines
;and wait for the IBM to handshake back. If the IBM doesn't respond
;within time FALSE is returned in A, else TRUE.
;
;INPUT
;	A	theCommand
;
;OUTPUT
;	A	boolean that indicates success, or fail
;
				PUBLIC			SendCommandToIBM
SendCommandToIBM	PROC

				PSHA										;hang on to the command byte to send
				LDD				#H2ITIMEOUT*CYCLESPERMS
				JSR				StartTimeout				;start timeout
..waitHostReady:
				LDAA			m_ReadyForCommand			;make sure the host is ready for the command
				BNE				..hostIsReady				;he is ready, send it to him
				JSR				CheckTimeout				;see if we timed out
				TSTA
				BEQ				..waitHostReady				;no, continue waiting
				PULA										;get the command byte clutter off of the stack
				BRA				..fail						;could not send it, so fail
..hostIsReady:
				LDAA			#FALSE
				STAA			m_ReadyForCommand			;set not ready, now
				PULA										;get the byte back
				STAA			H2IDATA						;send the byte to the IBM, interrupting him
..waitHostReceive:
				LDAA			m_ReadyForCommand			;wait for the host to get the command
				BNE				..succeed
				JSR				CheckTimeout				;see if we timed out
				TSTA
				BEQ				..waitHostReceive			;no, continue waiting
..fail:
				LDAA			#FALSE
				BRA				..exit
..succeed:
				LDAA			#TRUE
..exit:
				RTS

				ENDPROC

				END

